﻿var ProgressCellType = (function (_super) {
    __extends(ProgressCellType, _super);
    function ProgressCellType() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    //自定义属性
    ProgressCellType.prototype.CellValue = null;
    ProgressCellType.prototype.createContent = function () {
        var self = this;

        var element = this.CellElement;
        var cellTypeMetaData = element.CellType;
        var container = $("<div id='" + this.ID + "'></div>");
        container.css("width", element.Width);
        container.css("height", element.Height);
        container.css("box-sizing", "border-box");
        container.css("border", "0px");
        container.css("outline", "none");

        var innerContainer = $("<div id=" + this.ID + '_probar' + "><div id=" + this.ID + '_progress' + " role=" + "progressbar" + " data-transitiongoal=" + "" + "></div></div>");

        container.append(innerContainer);
        return container;
    };

    ProgressCellType.prototype.getValueFromElement = function () {
        return this.CellValue;
    };

    ProgressCellType.prototype.setValueToElement = function (element, value) {
        var self = this;
        n = Number(value);
        if (!isNaN(n)) {
            $("#" + this.ID + "_progress").attr("data-transitiongoal", value).progressbar({
                done: function () {
                    self.CellValue = value;
                    self.commitValue();}
            }); 
        } 
    };
    ProgressCellType.prototype.onLoad = function () {
        var info = this.getProgressCellTypeClass()     

        $("#" + this.ID + "_probar").addClass(info.fclassstr);
        $("#" + this.ID + "_progress").addClass(info.classstr);
        if (info.textclass === "") {
            $("#" + this.ID + "_progress").progressbar();
        }
        if (info.txtflag === true) {
            if (info.textclass === "fill") {
                $("#" + this.ID + "_progress").progressbar({ display_text: 'fill' });
            } else if (info.textclass === "center") {
                $("#" + this.ID + "_progress").progressbar({ display_text: 'center' });
            }
        } else if (info.txtflag === false) {
            if (info.textclass === "fill") {
                $("#" + this.ID + "_progress").progressbar({ display_text: 'fill', use_percentage: false});
            } else if (info.textclass === "center") {
                $("#" + this.ID + "_progress").progressbar({ display_text: 'center', use_percentage: false });
            }
        }
        
    };


    //自定义的方法
    ProgressCellType.prototype.getProgressCellTypeClass = function () {
        var cellTypeMetaData = this.CellElement.CellType;      
        var fclassstr = "";
        var classstr = "";
        var textclass = "";
        var txtflag = null;
        if (cellTypeMetaData.ProDirctClass === ProDirctEnum.EnumH) {

            if (cellTypeMetaData.PCssClass === PCssEnum.PCB) {
                fclassstr = "progress";
                classstr = "progress-bar";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCG) {
                fclassstr = "progress";
                classstr = "progress-bar progress-bar-success";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCBL) {
                fclassstr = "progress";
                classstr = "progress-bar progress-bar-info";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCY) {
                fclassstr = "progress";
                classstr = "progress-bar progress-bar-warning";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCR) {
                fclassstr = "progress";
                classstr = "progress-bar progress-bar-danger";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTB) {
                fclassstr = "progress  progress-striped";
                classstr = "progress-bar";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTG) {
                fclassstr = "progress  progress-striped";
                classstr = "progress-bar progress-bar-success";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTBL) {
                fclassstr = "progress  progress-striped";
                classstr = "progress-bar progress-bar-info";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTY) {
                fclassstr = "progress  progress-striped";
                classstr = "progress-bar progress-bar-warning";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTR) {
                fclassstr = "progress  progress-striped";
                classstr = "progress-bar progress-bar-danger";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTB) {
                fclassstr = "progress  progress-striped active";
                classstr = "progress-bar progress-bar-striped";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTG) {
                fclassstr = "progress  progress-striped active";
                classstr = "progress-bar progress-bar-success";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTBL) {
                fclassstr = "progress  progress-striped active";
                classstr = "progress-bar progress-bar-info";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTY) {
                fclassstr = "progress  progress-striped active";
                classstr = "progress-bar progress-bar-warning";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTR) {
                fclassstr = "progress  progress-striped active";
                classstr = "progress-bar progress-bar-danger";
            }            
        }
        if (cellTypeMetaData.ProDirctClass === ProDirctEnum.EnumHr) {
            if (cellTypeMetaData.PCssClass === PCssEnum.PCB) {
                fclassstr = "progress right";
                classstr = "progress-bar";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCG) {
                fclassstr = "progress right";
                classstr = "progress-bar progress-bar-success";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCBL) {
                fclassstr = "progress right";
                classstr = "progress-bar progress-bar-info";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCY) {
                fclassstr = "progress right";
                classstr = "progress-bar progress-bar-warning";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCR) {
                fclassstr = "progress right";
                classstr = "progress-bar progress-bar-danger";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTB) {
                fclassstr = "progress  progress-striped right";
                classstr = "progress-bar";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTG) {
                fclassstr = "progress  progress-striped right";
                classstr = "progress-bar progress-bar-success";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTBL) {
                fclassstr = "progress  progress-striped right";
                classstr = "progress-bar progress-bar-info";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTY) {
                fclassstr = "progress  progress-striped right";
                classstr = "progress-bar progress-bar-warning";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTR) {
                fclassstr = "progress  progress-striped right";
                classstr = "progress-bar progress-bar-danger";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTB) {
                fclassstr = "progress  progress-striped active right";
                classstr = "progress-bar progress-bar-striped";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTG) {
                fclassstr = "progress  progress-striped active right";
                classstr = "progress-bar progress-bar-success";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTBL) {
                fclassstr = "progress  progress-striped active right";
                classstr = "progress-bar progress-bar-info";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTY) {
                fclassstr = "progress  progress-striped active right";
                classstr = "progress-bar progress-bar-warning";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTR) {
                fclassstr = "progress  progress-striped active right";
                classstr = "progress-bar progress-bar-danger";
            }    
        }
        if (cellTypeMetaData.ProDirctClass === ProDirctEnum.EnumV) {
            
            if (cellTypeMetaData.PCssClass === PCssEnum.PCB) {
                fclassstr = "progress vertical";
                classstr = "progress-bar";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCG) {
                fclassstr = "progress vertical";
                classstr = "progress-bar progress-bar-success";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCBL) {
                fclassstr = "progress vertical";
                classstr = "progress-bar progress-bar-info";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCY) {
                fclassstr = "progress vertical";
                classstr = "progress-bar progress-bar-warning";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCR) {
                fclassstr = "progress vertical";
                classstr = "progress-bar progress-bar-danger";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTB) {
                fclassstr = "progress  progress-striped vertical";
                classstr = "progress-bar";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTG) {
                fclassstr = "progress  progress-striped vertical";
                classstr = "progress-bar progress-bar-success";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTBL) {
                fclassstr = "progress  progress-striped vertical";
                classstr = "progress-bar progress-bar-info";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTY) {
                fclassstr = "progress  progress-striped vertical";
                classstr = "progress-bar progress-bar-warning";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTR) {
                fclassstr = "progress  progress-striped vertical";
                classstr = "progress-bar progress-bar-danger";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTB) {
                fclassstr = "progress  progress-striped active vertical";
                classstr = "progress-bar progress-bar-striped";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTG) {
                fclassstr = "progress  progress-striped active vertical";
                classstr = "progress-bar progress-bar-success";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTBL) {
                fclassstr = "progress  progress-striped active vertical";
                classstr = "progress-bar progress-bar-info";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTY) {
                fclassstr = "progress  progress-striped active vertical";
                classstr = "progress-bar progress-bar-warning";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTR) {
                fclassstr = "progress  progress-striped active vertical";
                classstr = "progress-bar progress-bar-danger";
            }   
        }
        if (cellTypeMetaData.ProDirctClass === ProDirctEnum.EnumVb) {
           
            if (cellTypeMetaData.PCssClass === PCssEnum.PCB) {
                fclassstr = "progress vertical bottom";
                classstr = "progress-bar";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCG) {
                fclassstr = "progress vertical bottom";
                classstr = "progress-bar progress-bar-success";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCBL) {
                fclassstr = "progress vertical bottom";
                classstr = "progress-bar progress-bar-info";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCY) {
                fclassstr = "progress vertical bottom";
                classstr = "progress-bar progress-bar-warning";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCR) {
                fclassstr = "progress vertical bottom";
                classstr = "progress-bar progress-bar-danger";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTB) {
                fclassstr = "progress  progress-striped vertical bottom";
                classstr = "progress-bar";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTG) {
                fclassstr = "progress  progress-striped vertical bottom";
                classstr = "progress-bar progress-bar-success";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTBL) {
                fclassstr = "progress  progress-striped vertical bottom";
                classstr = "progress-bar progress-bar-info";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTY) {
                fclassstr = "progress  progress-striped vertical bottom";
                classstr = "progress-bar progress-bar-warning";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCTR) {
                fclassstr = "progress  progress-striped vertical bottom";
                classstr = "progress-bar progress-bar-danger";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTB) {
                fclassstr = "progress  progress-striped active vertical bottom";
                classstr = "progress-bar progress-bar-striped";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTG) {
                fclassstr = "progress  progress-striped active vertical bottom";
                classstr = "progress-bar progress-bar-success";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTBL) {
                fclassstr = "progress  progress-striped active vertical bottom";
                classstr = "progress-bar progress-bar-info";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTY) {
                fclassstr = "progress  progress-striped active vertical bottom";
                classstr = "progress-bar progress-bar-warning";
            }
            if (cellTypeMetaData.PCssClass === PCssEnum.PCDTR) {
                fclassstr = "progress  progress-striped active vertical bottom";
                classstr = "progress-bar progress-bar-danger";
            }  
        }    


        if (cellTypeMetaData.PTextClass === PTextEnum.ETNone) {
            textclass = "";

        } else if (cellTypeMetaData.PTextClass === PTextEnum.ETPc) {
            textclass = "fill";
            txtflag = true;
        }
        else if (cellTypeMetaData.PTextClass === PTextEnum.ETNc) {
            textclass = "fill";
            txtflag = false;
        }
        else if (cellTypeMetaData.PTextClass === PTextEnum.ETCPc) {
            textclass = "center";
            txtflag = true;
        }
        else if (cellTypeMetaData.PTextClass === PTextEnum.ETCNc) {
            textclass = "center";
            txtflag = false;
        }
        return {
            fclassstr: fclassstr,
            classstr: classstr,
            textclass: textclass,
            txtflag: txtflag
        };
    }

    ProgressCellType.prototype.disable = function () {
        _super.prototype.disable.call(this);
    };

    ProgressCellType.prototype.enable = function () {
        _super.prototype.enable.call(this);
    };

    return ProgressCellType;
}(Forguncy.CellTypeBase));
var ProDirctEnum = {
    EnumH: 0,
    EnumHr: 1,
    EnumV: 2,
    EnumVb: 3
};
var PCssEnum = {
    PCB: 0,
    PCG: 1,
    PCBL: 2,
    PCY: 3,
    PCR: 4,
    PCTB: 5,
    PCTG: 6,
    PCTBL: 7,
    PCTY: 8,
    PCTR: 9,
    PCDTB: 10,
    PCDTG: 11,
    PCDTBL: 12,
    PCDTY: 13,
    PCDTR: 14
};
var PTextEnum = {
    ETNone: 0,
    ETPc: 1,
    ETNc: 2,
    ETCPc: 3,
    ETCNc: 4
};
// Key format is "Namespace.ClassName, AssemblyName"
Forguncy.Plugin.CellTypeHelper.registerCellType("ProgressCellType.ProgressCellType, ProgressCellType", ProgressCellType);